// #zegzav:pastcomment

#include "stdafx.h"
#include "emule.h"
#include "PastComment.h"
#include "otherfunctions.h"

static const CString strPastCommentNul(_T(""));

CPastComment::CPastComment() : m_eRating(PF_RATING_NONE)
{
	md4clr(m_ClientHash);
}

CPastComment::CPastComment(uchar client[16]) : m_eRating(PF_RATING_NONE)
{
	md4cpy(m_ClientHash, client);
}

CPastComment::CPastComment(uchar client[16], const CString &strClientName) : m_eRating(PF_RATING_NONE), m_strClientName(strClientName)
{
	md4cpy(m_ClientHash, client);
}

CPastComment::CPastComment(uchar client[16], const CString &strClientName, const CString &strFileName, const CString &strComment, EnumPartFileRating eRating)
	:  m_strClientName(strClientName), m_strFileName(strFileName), m_strComment(strComment), m_eRating(eRating)
{ 
	md4cpy(m_ClientHash, client);
}

bool CPastComment::operator==(const CPastComment &pc) const
{
	return (md4cmp(m_ClientHash, pc.m_ClientHash) == 0);
}

bool CPastCommentList::GetCommentRating(uchar client[16], CString *pstrComment, EnumPartFileRating *peRate) const
{
	POSITION		pos;

	if ((pos = Find(CPastComment(client))) == NULL)
	{
		*pstrComment= _T("");
		*peRate = PF_RATING_NONE;
		return false;
	}
	CPastComment	pc = GetAt(pos);

	*pstrComment = pc.GetComment();
	*peRate = pc.GetRating();
	return true;
}

const CString &CPastCommentList::GetFileName(uchar client[16])
{
	POSITION pos;
	if ((pos= Find(CPastComment(client))) == NULL)
		return strPastCommentNul;
	return GetAt(pos).GetFileName();
}

const CString &CPastCommentList::GetComment(uchar client[16])
{
	POSITION pos;
	if ((pos= Find(CPastComment(client))) == NULL)
		return strPastCommentNul;
	return GetAt(pos).GetComment();
}

byte CPastCommentList::GetRate(uchar client[16])
{
	POSITION pos;
	if ((pos= Find(CPastComment(client))) == NULL)
		return 0;
	return GetAt(pos).GetRating();
}

void CPastCommentList::Add(uchar client[16], const CString &strClientName, const CString &strFileName, const CString &strComment, EnumPartFileRating eRating)
{
	POSITION pos;
	CPastComment pc(client, strClientName, strFileName, strComment, eRating);
	if ((pos= Find(pc)) == NULL)
		AddTail(pc);
	else
		SetAt(pos, pc);
}

void CPastCommentList::Remove(uchar client[16])
{
	POSITION pos;
	if ((pos= Find(CPastComment(client))) == NULL)
		return;
	RemoveAt(pos);
}
